#include "stdafx.h"
#include <set>
#include <ablib/textfile.h>
#include <algorithm>
#include "analyze.h"
#include "TeXProject.h"

//ˑ֌WɗpĂł낤gqB
const TCHAR *Analyze::m_kaku[] = {_T("aux"),_T("toc"),_T("lot"),_T("lof"),NULL};
extern ablib::string tmp_string;

void trimEnd(ablib::string &s) {
	s.erase(std::find_if(s.rbegin(), s.rend(), [](unsigned char c) { return !isspace(c);	}).base(), s.end());
}

//  = 1, \relax̂ = 2, \relax+\gdef\@abspage@last = 3, ȊO = 4
int GetLaTeXStatus(const std::vector<char> &buf) {
	std::vector<ablib::string> lines;
	size_t line_start = 0;
	for (size_t i = 0; i < buf.size(); ++i) {
		if (buf[i] == '\r' || buf[i] == '\n') {
			auto s = ablib::string(&(buf[line_start]), i - line_start);
			trimEnd(s);
			lines.push_back(s);
			if (buf[i] == '\r' && buf[i + 1] == '\n')++i;
			line_start = i + 1;
		}
	}
	if (line_start < buf.size()) {
		auto s = ablib::string(&(buf[line_start]), buf.size() - line_start);
		trimEnd(s);
		lines.push_back(s);
	}
	if (lines.size() == 0)return 1;
	if (lines[0] != "\\relax") return 4;
	if (lines.size() == 1) return 2;
	int possible_status;
	for (auto &s : lines) {
		DEBUGSTRING(("In Analyze, aux: " + s).c_str());
	}
	if (lines[1] == "") possible_status = 2;
	else {
		possible_status = 3;
		const char *gdef = "\\gdef";
		const char *abspage_last = "\\@abspage@last";
		if (lines[1].find(gdef) != 0)return 4;
		int l = ::lstrlen(gdef);
		while (lines[1][l] == ' ')++l;
		if (lines[1][l] != '\\')return 4;
		if (lines[1].find(abspage_last, l) != l)return 4;
		l += ::lstrlen(abspage_last);
		while (lines[1][l] == ' ')++l;
		if (lines[1][l] != '{')return 4;
		++l;
		while (::isdigit(lines[1][l]))++l;
		if (lines[1][l] != '}')return 4;
		++l;
		if (lines[1][l] != '\0')return 4;
	}
	for (size_t i = 2; i < lines.size(); ++i) {
		if (lines[i] != "") return 4;
	}
	return possible_status;
}

bool Analyze::LaTeXCheck() {
	if (m_forcelatex) {
		m_forcelatex = false;
		return true;
	}
	ablib::string file;
	std::vector<char> buf;
	bool rv = false;
	for (std::vector<ablib::string>::size_type i = 0; i < m_files.size(); ++i) {
		for (const TCHAR **kaku = m_kaku; *kaku; ++kaku) {
			file = m_files[i].file;
			DeleteExttex(file);
			file += *kaku;
			FILE *fp = ::_tfopen(file.c_str(), _T("r"));
			std::map<ablib::string, std::vector<char> >::iterator ite = m_files[i].aux.find(*kaku);
			bool cur_buf_exist = false;
			if (fp) {
				buf.clear();
				size_t size;
				char b[4096];
				while ((size = ::fread(b, sizeof(char), 4096, fp)) > 0) {
					buf.insert(buf.end(), b, b + size);
				}
				::fclose(fp);
				cur_buf_exist = true;
			}
			if (!rv) {
				if (i == 0 && ::lstrcmp(*kaku, _T("aux")) == 0) {
					int new_status;
					if (!cur_buf_exist)new_status = 0;
					else new_status = GetLaTeXStatus(buf);
					int old_status;
					if (ite == m_files[i].aux.end())old_status = 0;
					else old_status = GetLaTeXStatus(ite->second);
					if (new_status == 4) {
						if (old_status == 4) {
							if (buf != ite->second)rv = true;
						} else rv = true;
					} else if (new_status == 1 || new_status == 2 || new_status == 3) {
						if (old_status == 4) rv = true;
					}
				} else {
					if (cur_buf_exist) {
						if (ite == m_files[i].aux.end())rv = true;
						else if (buf != ite->second)rv = true;
					} else if (ite != m_files[i].aux.end()) {
						rv = true;
					}
				}
			}
			if (cur_buf_exist)m_files[i].aux[*kaku] = buf;
			else m_files[i].aux.erase(*kaku);
		}
	}
	return rv;
}

bool Analyze::BibTeXCheck(){
	if(m_bibtex)return false;
	bool existbibdata = false;
	ablib::TextFile tf;
	std::set<ablib::string> bibs,cits;
	for(std::vector<ablib::string>::size_type i = 0 ; i < m_files.size() ; ++i){
		ablib::string aux = m_files[i].file;
		DeleteExttex(aux);
		aux += _T("aux");
		if(tf.Open(aux,ablib::TextFile::read)){
			TCHAR buf[4096];
			while(tf.ReadLine(buf,4095)){
				auto bibdata = ::_tcsstr(buf, _T("\\bibdata{"));
				if (!existbibdata && bibdata != nullptr)existbibdata = true;
				auto bibcite = ::_tcsstr(buf, _T("\\bibcite{"));
				if(bibcite != nullptr){
					// ::lstrlen("\\bibcite{") = 9
					TCHAR *p = ::_tcsstr(bibcite + 9,_T("}"));
					if(p){
						*p = '\0';
						bibs.insert(bibcite + 9);
					}
				}
				auto citation = ::_tcsstr(buf, _T("\\citation{"));
				if(citation != nullptr){
					// ::lstrlen("\\citation{") = 10
					TCHAR *p = ::_tcsstr(citation + 10,_T("}"));
					if(p){
						*p = '\0';
						cits.insert(citation + 10);
					}
				}
			}
			tf.Close();
		}
	}
	bool rv = existbibdata && (bibs != cits);
	if(rv){
		m_forcelatex = true;
		m_bibtex = true;
	}
	return rv;
}


bool Analyze::MakeIndexCheck(){
	if(m_makeindex)return false;
	ablib::string f = m_files[0].file;
	DeleteExttex(f);
	f += _T("idx");
	if(ExistsFile(f.c_str())){
		m_forcelatex = true;
		m_makeindex = true;
		return true;
	}else return false;
}

const TCHAR *Analyze::Start(const TCHAR *mainfile){
	m_forcelatex = false;m_makeindex = false;m_bibtex = false;
	m_files.clear();m_files.push_back(FileData(mainfile));
	TeXProject tp;
	tp.CreateFileList(mainfile);
	std::vector<TeXProject::FileData> fdata = tp.GetFileData();
	for(std::vector<TeXProject::FileData>::size_type i = 0 ; i < fdata.size() ; ++i){
		if(fdata[i].type == TeXProject::FileData::include)m_files.push_back(FileData(fdata[i].name));
	}
	LaTeXCheck();// .auxǂݍނ߂

	tmp_string = ablib::string(_T("latex\n")) + mainfile;
	return tmp_string.c_str();
}

const TCHAR *Analyze::Next(){
	if(LaTeXCheck())tmp_string = _T("latex\n") + m_files[0].file;
	else if(MakeIndexCheck())tmp_string = _T("makeindex\n") + m_files[0].file;
	else if(BibTeXCheck())tmp_string = _T("bibtex\n") + m_files[0].file;
	else tmp_string = _T("");
	return tmp_string.c_str();
}

intptr_t Analyze::Finish(){return TRUE;}

void Analyze::DeleteExttex(ablib::string &f){
	ablib::string::size_type n = f.length();
	if(n >= 4 &&
		(f[n - 1] == 'x' || f[n - 1] == 'X') &&
		(f[n - 2] == 'e' || f[n - 2] == 'E') &&
		(f[n - 3] == 't' || f[n - 3] == 'T') &&
		(f[n - 4] == '.')
	)f.erase(n - 3);
	return;
}
