#ifndef __FILE_H__
#define __FILE_H__

#include <vector>
#include <ablib/TextFile.h>
#include <system/File.h>
#include <system/FindFile.h>

/**
t@C̊֐񋟁B
KɐFXl߂ĂB
*/

class File
{
public:
	File(){}
	~File();
	intptr_t OpenFile(const TCHAR *fname,const TCHAR *mode);
	const TCHAR *ReadFileLine(intptr_t fp);
	intptr_t Write(const TCHAR *text, intptr_t fp);
	intptr_t CloseFile(intptr_t fp);
	intptr_t IsEOF(intptr_t fp);
	const TCHAR *FindFirstFile(const TCHAR *pattern);
	const TCHAR *FindNext();
	intptr_t FindClose(){m_findfile.Close();return TRUE;}
	static intptr_t CompareTimeStamp(const TCHAR *fname1,const TCHAR *fname2);
	static const TCHAR *OpenFileDialog(HWND hwnd,const TCHAR *title,const TCHAR *filter,const TCHAR *defdir);
	static const TCHAR *OpenDirDialog(HWND hwnd,const TCHAR *title,const TCHAR *defdir);
	static intptr_t CheckSameFile(const TCHAR *filename1,const TCHAR *filename2);
	static intptr_t SortFile(const TCHAR *fname,const TCHAR *fname2, intptr_t casesense, intptr_t width);
	static const TCHAR *TransRegularPath(const TCHAR *fn);
	static DWORD GetFilesize(const TCHAR *fname){return ablib::system::File::GetSize(fname);}
	static bool ExistsFile(const TCHAR *filename);
	static const TCHAR *Which(const TCHAR *cmd, intptr_t n);
	static intptr_t CreateDir(const TCHAR *dir);
	static intptr_t DeleteFiles(const TCHAR *file);
	static const TCHAR *GetDrives();
	static const TCHAR *GetLongPathName(const TCHAR *sfn);
	static const TCHAR *GetShortPathName(const TCHAR *lfn);
	static const TCHAR *GetAssociation(const TCHAR *ext);
	static ablib::string GetTempDir();

private:
	std::vector<FILE *> m_fp;
	ablib::system::FindFile m_findfile;
	ablib::TextFile m_textfile;
	static intptr_t compare(const void *arg1,const void *arg2);

	NOCOPY(File);
};

#endif //__FILE_H__

