#include "stdafx.h"
#include "input.h"
#include "resource.h"

extern HINSTANCE g_dllint;

Input::Input(void) : BaseModalDlg(g_dllint){}

const TCHAR *Input::Create(HWND hwnd,TCHAR *title,TCHAR *msg,TCHAR *def){
	m_rv = _T("");
	m_title = title;m_msg = msg;m_def = def;
	ablib::window::Wnd w(hwnd);
	BaseModalDlg::Create(&w,IDD_INPUT);
	return m_rv.c_str();
}

bool Input::OnInitDialog(ablib::window::Dialog *wnd){
	wnd->SetTitle(m_title);
	ablib::window::StaticText(wnd,IDC_MSG).SetText(m_msg);
	ablib::window::Edit edit(wnd,IDC_EDIT);
	edit.SetText(m_def);
	edit.SetFocus();
	edit.SetSel(m_def.length(),m_def.length());
	return false;
}

bool Input::OnCommand(ablib::window::Dialog *wnd,int id, intptr_t param){
	switch(id){
	case IDOK:
		m_rv = ablib::window::Edit(wnd,IDC_EDIT).GetText();
		wnd->Destroy(TRUE);
		return true;
	case IDCANCEL:
		wnd->Destroy(FALSE);
		return true;
	default:
		return false;
	}
}
