#ifndef __LISTBOX_H__
#define __LISTBOX_H__

#include <functional>
#include "listboxwnd.h"

/**
⊮p̃Xg{bNXB
\ɂListBoxWndNXɂčLISTBOXgpB
*/

class ListBox
{
public:
	ListBox(void);
	~ListBox(void);
	intptr_t Create(HWND hwnd, intptr_t x, intptr_t y,const TCHAR *listfile,const TCHAR *comment = NULL);
	intptr_t Destroy(){m_listwnd.Destroy();return TRUE;}
	intptr_t Set(TCHAR *set, intptr_t val);
	const TCHAR *GetText(intptr_t n){return m_listwnd.GetShowText(n);}
	const TCHAR *GetSelText(){return GetText(GetSel());}
	intptr_t GetSel() const{return m_listwnd.GetSelect();}
	intptr_t SelectFromText(TCHAR *text);
	intptr_t SetSel(intptr_t n, intptr_t sel = TRUE){m_listwnd.SetSelect(n,sel);m_listwnd.Update();return TRUE;}
	intptr_t IsCreated(){if(m_listwnd.IsExist())return TRUE;else return FALSE;}
	intptr_t Up(intptr_t i, intptr_t sel = TRUE){if(m_listwnd.Up(i,sel))return TRUE;else return FALSE;}
	intptr_t GetCount(){return m_listwnd.GetCount();}
	intptr_t SetFont(TCHAR *fontname, intptr_t size){return m_listwnd.SetFont(fontname,size);}
	intptr_t SetSize(intptr_t v, intptr_t h){m_listwnd.SetSize(v,h);return TRUE;}
	intptr_t SetPos(intptr_t x, intptr_t y){m_listwnd.SetPos(x,y);return TRUE;}
	intptr_t SetShow(intptr_t show){m_listwnd.SetShow(show);return TRUE;}
	intptr_t Redraw(){return static_cast<intptr_t>(m_listwnd.Update());}
	intptr_t GetWindowHeight(){return m_listwnd.GetWindowHeight();}
	intptr_t GetCommentWindowHeight(){return m_listwnd.GetCommentWindowHeight();}
	const TCHAR *GetCommonStr(TCHAR *text);

private:
	struct LISTSET{
		LISTSET() : Show_only_match(false), CaseSense(false), Sort(false), Uniq(false), Width(false), comment_fix(false){}
		bool Show_only_match;
		bool CaseSense;
		bool Sort;
		bool Uniq;
		bool Width;
		bool comment_fix;
	}m_listset;

	ListBoxWnd m_listwnd;
	intptr_t FirstListText(TCHAR *text);
	std::function<int(const TCHAR*,int,const TCHAR*,int)> m_compare;
	intptr_t comparestr(const TCHAR *a,const TCHAR *b){return m_compare(a,-1,b,-1);}
	bool firstmatchstr(const TCHAR *a,const TCHAR *b);
	void Escape(ablib::string &str);

	NOCOPY(ListBox);

};
#endif //__LISTBOX_H__

