#include "stdafx.h"
#include <algorithm>
#include <window/Graphic.h>
#include <ablib/SmallVector.h>
#include "listboxwnd.h"

extern HINSTANCE g_dllint;
DWORD ListBoxWnd::Buffer::STRDATA::opt = 0;


TCHAR        WindowClassName[] = _T("ForTeXListBox");
TCHAR CommentWindowClassName[] = _T("ForTeXListBoxComment");

ListBoxWnd::ListBoxWnd() : m_isshow(false),
m_hsize(200),m_vsize(6),m_parent(NULL),m_comwnd(&m_buf),
BaseWnd(WindowClassName,WS_POPUP | WS_BORDER | WS_VSCROLL,g_dllint){
}

ListBoxWnd::CommentWnd::CommentWnd(Buffer *buf) : BaseWnd(CommentWindowClassName,WS_POPUP | WS_BORDER,g_dllint),m_buf(buf){}

ablib::window::Window *ListBoxWnd::Create(HWND hwnd, intptr_t x, intptr_t y,HINSTANCE appint,bool comment,bool commentfix){
	m_buf.m_issel = false;
	m_buf.m_selindex = 0;
	delete m_parent;
	m_parent = new ablib::window::Window(hwnd);

	ablib::window::Window *me = BaseWnd::Create(m_parent);
	if(!me)return NULL;
	if(m_isshow)me->ShowWindow(ablib::window::Wnd::sw_show);
	GetWindow()->Move(ablib::window::Point((int)x,(int)y),ablib::window::Size(0,0));

	if(comment){
		m_comment = true;
		m_comwnd.m_commentfix = commentfix;
		m_comwnd.Create(m_parent);
	}else m_comment = false;
	Update();
	return me;
}


bool ListBoxWnd::OnCreate(ablib::window::Window *wnd){
	m_font = wnd->GetFontData();
	wnd->SetTextColor(
		ablib::window::rgb(::GetSysColor(COLOR_WINDOWTEXT)),
		ablib::window::rgb(::GetSysColor(COLOR_WINDOW)));
	wnd->SetFillColor(ablib::window::rgb(::GetSysColor(COLOR_WINDOW)));
	wnd->SetLineStyle(ablib::window::rgb(::GetSysColor(COLOR_WINDOWTEXT)),1,ablib::window::Window::ps_dot);
//	ablib::window::Rect rc = wnd->GetRect();
//	wnd->Move(
//		ablib::window::Point(rc.left,rc.top),
//		ablib::window::Point(m_hsize,m_vsize * TextHeight() + 2));
	SetFont(m_fontname.c_str(),m_fontsize);
	m_comwnd.SetShow(m_isshow);
	m_comwnd.SetListWnd(wnd);
	return true;
}

bool ListBoxWnd::CommentWnd::OnCreate(ablib::window::Window *wnd){
	SetFont(m_fontname.c_str(),m_fontsize);
	wnd->SetTextColor(
		ablib::window::rgb(::GetSysColor(COLOR_WINDOWTEXT)),
		ablib::window::rgb(::GetSysColor(COLOR_WINDOW)));
	wnd->SetFillColor(ablib::window::rgb(::GetSysColor(COLOR_WINDOW)));
	return true;
}

bool ListBoxWnd::OnDestroy(ablib::window::Window *wnd){
	if(m_comwnd.GetWindow())m_comwnd.GetWindow()->Destroy();
	return true;
}

void ListBoxWnd::SetScroll(intptr_t pos){
	ablib::window::Window *wnd = GetWindow();
	auto oldpos = wnd->GetVScrollBar()->GetPos();
	wnd->GetVScrollBar()->SetRange(0,m_buf.GetShowCount() - 1);
	wnd->GetVScrollBar()->SetPage(m_vsize);
	wnd->GetVScrollBar()->SetPos(pos);
	auto newpos = wnd->GetVScrollBar()->GetPos();
	if(newpos != oldpos){
		wnd->GetVScrollBar()->WindowScroll(TextHeight() * (oldpos - newpos));
		if(m_comment)m_comwnd.GetWindow()->Invalidate();
	}
	return;
}

//Xg`
bool ListBoxWnd::OnPaint(ablib::window::Window *wnd){
	ablib::window::Graphic g(wnd);
	if(!m_isshow){
		if(wnd->GetWindowState() != ablib::window::Wnd::sw_hide){
			wnd->ShowWindow(ablib::window::Window::sw_hide);
			m_parent->SetActive();
		}
	}else{
		if(wnd->GetWindowState() == ablib::window::Wnd::sw_hide){
			wnd->ShowWindow(ablib::window::Window::sw_show);
			m_parent->SetActive();
		}
	}

	auto scroll = wnd->GetVScrollBar()->GetPos();
	auto line = g.GetPaintRect().top / TextHeight();
	g.FillRect(ablib::window::Rect(0,line * TextHeight(),m_hsize,m_vsize * TextHeight() + 4));
    
	ablib::string text;
	for(; line < m_vsize ; ++line){
		if(!m_buf.GetShowStr(line + scroll,text))break;
		if(line + scroll == m_buf.m_selindex){
			if(m_buf.m_issel){
				wnd->SetFillColor(ablib::window::rgb(::GetSysColor(COLOR_HIGHLIGHT)));
				wnd->SetTextColor(
					ablib::window::rgb(::GetSysColor(COLOR_HIGHLIGHTTEXT)),
					ablib::window::rgb(::GetSysColor(COLOR_HIGHLIGHT)));
				g.SetUpdate();
				g.FillRect(ablib::window::Rect(0,line * TextHeight(),m_hsize - 1,(line + 1)*TextHeight()));
				g.WriteText(ablib::window::Point(2,2 + line * TextHeight()),text,text.length());
				wnd->SetTextColor(
					ablib::window::rgb(::GetSysColor(COLOR_WINDOWTEXT)),
					ablib::window::rgb(::GetSysColor(COLOR_WINDOW)));
				wnd->SetFillColor(ablib::window::rgb(::GetSysColor(COLOR_WINDOW)));
				g.SetUpdate();
			}else{
				g.WriteText(ablib::window::Point(2,2 + line * TextHeight()),text,text.length());
				g.DrawLine(ablib::window::Point(0,line * TextHeight()),ablib::window::Point(m_hsize - 1,line * TextHeight()));
				g.DrawLine(ablib::window::Point(m_hsize - 1,line * TextHeight()),ablib::window::Point(m_hsize - 1,(line + 1)* TextHeight()));
				g.DrawLine(ablib::window::Point(m_hsize - 1,(line + 1)* TextHeight()),ablib::window::Point(0,(line + 1)* TextHeight()));
				g.DrawLine(ablib::window::Point(0,(line + 1)* TextHeight()),ablib::window::Point(0,line* TextHeight()));
			}
		}else{
			g.WriteText(ablib::window::Point(2,2 + line * TextHeight()),text,text.length());
		}
	}
	if(m_comwnd.GetWindow())m_comwnd.OnPaint();
	return true;
}

//XN[
bool ListBoxWnd::OnVScroll(ablib::window::Window *wnd, intptr_t dy){
	auto scroll = wnd->GetVScrollBar()->GetPos();
	scroll += dy;
	SetScroll(scroll);
	return true;
}

//}EX
bool ListBoxWnd::OnLButtonDown(ablib::window::Window *wnd,ablib::window::Mouse *mos){
	if(m_buf.GetLineCount() == 0)return false;
	auto spos = wnd->GetVScrollBar()->GetPos();
	m_buf.m_selindex = spos + mos->GetPos().y / TextHeight();
	m_buf.m_issel = true;
	wnd->Invalidate();
	if(m_comment)m_comwnd.GetWindow()->Invalidate();
	return true;
}

//Rg`
bool ListBoxWnd::CommentWnd::OnPaint(ablib::window::Window *wnd){
	ablib::window::Graphic g(wnd);
	ablib::window::Window active(::GetActiveWindow());
	g.FillRect(wnd->GetClientRect());

	ablib::string text;
	m_buf->GetShowComment(m_buf->m_selindex,text);
	if(!m_isshow ||
		(
		(!m_commentfix || !m_buf->GetFixedComment(text)) && 
		(!m_buf->m_issel || !m_buf->GetShowComment(m_buf->m_selindex,text) || text == _T(""))
		)
	){
		if(wnd->GetWindowState() != ablib::window::Window::sw_hide){
			wnd->ShowWindow(ablib::window::Wnd::sw_hide);
			active.SetActive();
		}
		return true;
	}else{
		if(wnd->GetWindowState() == ablib::window::Wnd::sw_hide){
			wnd->ShowWindow(ablib::window::Wnd::sw_show);
			active.SetActive();
		}
	}

	ablib::string::size_type p = 0,q = 0;
	intptr_t maxlen = 0;
	intptr_t textwidth = 0;// 񒷂
	intptr_t line = 0;
	ablib::window::FontData fd = wnd->GetFontData();
	while(true){
		p = text.find(_T("\n"),q);
		if(p == ablib::string::npos){
			g.WriteText(ablib::window::Point(2 + textwidth,1 + (1 + TextHeight()) * line),text.c_str() + q,text.length() - q);
			textwidth += wnd->GetTextExtent(text.c_str() + q,text.length() - q).width;
			maxlen = Max(textwidth,maxlen);
			break;
		}
		g.WriteText(ablib::window::Point(2 + textwidth,1 + (1 + TextHeight()) * line),text.c_str() + q,p - q);
		auto w = wnd->GetTextExtent(text.c_str() + q,p - q).width;
		if(w < 0)textwidth += m_font.avewidth*(p - q);
		else textwidth += w;
		++p;
		switch(text[p]){
		case 'n':
			maxlen = Max(maxlen,textwidth);
			textwidth = 0;
			++line;++p;
			break;
		case 'B':
			fd.weight = FW_BOLD;
			wnd->SetFont(fd);
			g.SetUpdate();
			++p;
			break;
		case 'E':
			fd.weight = FW_REGULAR;
			wnd->SetFont(fd);
			g.SetUpdate();
			++p;
			break;
		default:
			break;
		}
		q = p;
	}
	fd.weight = FW_REGULAR;
	wnd->SetFont(fd);

	ablib::window::Rect rc = m_listwnd->GetRect();
	wnd->Move(ablib::window::Point(rc.left,rc.bottom + 1),
		ablib::window::Size(maxlen + 8,(TextHeight() + 1) * (line + 1)));
	active.SetActive();

	wnd->Update();
	return true;
}

//ՂŁ[
bool ListBoxWnd::Update(){
	if(!GetWindow())return false;
	auto pos = m_buf.m_selindex - m_vsize / 2;
	SetScroll(pos);
	ablib::window::Window active(::GetActiveWindow());
	if(m_isshow){
		GetWindow()->ShowWindow(ablib::window::Wnd::sw_show);
		ablib::window::Rect rc = GetWindow()->GetRect();
		GetWindow()->Move(
			ablib::window::Point(rc.left,rc.top),
			ablib::window::Size(m_hsize,m_vsize * TextHeight() + 2));
	}else GetWindow()->ShowWindow(ablib::window::Wnd::sw_hide);
	active.SetActive();
	GetWindow()->Invalidate();
	if(m_comwnd.GetWindow())m_comwnd.GetWindow()->Invalidate();
	return true;
}

//グI
bool ListBoxWnd::Up(intptr_t n, intptr_t sel){
	if(m_buf.GetLineCount() == 0)return false;
	auto oldindex = m_buf.m_selindex;
	m_buf.m_selindex -= n;
	if(m_buf.m_selindex < 0)m_buf.m_selindex = 0;
	else if(m_buf.m_selindex >= m_buf.GetShowCount())m_buf.m_selindex = m_buf.GetShowCount() - 1;
	if(oldindex == m_buf.m_selindex && (sel?true:false) == m_buf.m_issel)return false;
	m_buf.m_issel = (sel ? true : false);

	auto pos = GetWindow()->GetVScrollBar()->GetPos();

	if(m_buf.m_selindex >= pos + m_vsize - 1)pos = m_buf.m_selindex - m_vsize + 1;
	else if(m_buf.m_selindex < pos)pos = m_buf.m_selindex;
	SetScroll(pos);
	GetWindow()->Invalidate();
	if(m_comwnd.GetWindow())m_comwnd.GetWindow()->Invalidate();
	return true;
}

intptr_t ListBoxWnd::SetFont(const TCHAR *fontname, intptr_t size){
	m_fontname = fontname;m_fontsize = size;
	if(GetWindow()){
		GetWindow()->SetFont(ablib::window::FontData(fontname,m_fontsize));
		m_font = GetWindow()->GetFontData();
	}
	m_comwnd.SetFont(m_fontname,m_fontsize);
	return TRUE;
}

void ListBoxWnd::CommentWnd::SetFont(const ablib::string &fontname, intptr_t fontsize){
	m_fontname = fontname;m_fontsize = fontsize;
	if(GetWindow()){
		GetWindow()->SetFont(ablib::window::FontData(fontname.c_str(),fontsize));
		m_font = GetWindow()->GetFontData();
	}
}

//ȉobt@
bool ListBoxWnd::Buffer::InsertText(intptr_t line,const STRDATA &data){
	if(line < 0 || line > GetLineCount())return false;
	m_buf.insert(m_buf.begin() + line,data);
	if(data.show){
		if(m_showline.back() < line)m_showline.push_back(line);
		else{
			m_showline.push_back(m_showline.back());
			for(auto i = GetShowCount() - 2 ; i >= 0 && m_showline[i] > line ; --i){
				m_showline[i - 1] = m_showline[i];
				m_showline[i] = line;
			}
		}
	}
	return true;
}

bool ListBoxWnd::Buffer::DeleteText(intptr_t line){
	if(line < 0 || line >= GetLineCount())return false;
	if(m_buf[line].show){
		int i;
		for(i = 0 ; i < GetShowCount() ; ++i)if(m_showline[i] == line)break;
		for(; i < GetShowCount() - 1; ++i)m_showline[i] = m_showline[i + 1];
		m_showline.pop_back();
	}
	for(auto i = line ; i < GetLineCount() - 1; ++i)m_buf[i] = m_buf[i + 1];
	m_buf.pop_back();
	return true;
}

void ListBoxWnd::Buffer::AddText(const STRDATA &data){
	m_buf.push_back(data);
	if(data.show)m_showline.push_back(GetLineCount() - 1);
}

void ListBoxWnd::Buffer::ShowClear(){
	for(int i = 0 ; i < GetLineCount() ; ++i)m_buf[i].show = false;
	m_showline.clear();
}

void ListBoxWnd::Buffer::Sort(){
	std::sort(m_buf.begin(),m_buf.end());
	m_showline.clear();
	for(int i = 0 ; i < GetLineCount() ; ++i)if(m_buf[i].show)m_showline.push_back(i);
	return;
}

void ListBoxWnd::Buffer::Uniq(){
	std::sort(m_buf.begin(),m_buf.end());
	std::vector<STRDATA>::iterator p = std::unique(m_buf.begin(),m_buf.end());
	m_buf.erase(p,m_buf.end());
	m_showline.clear();
	for(int i = 0 ; i < GetLineCount() ; ++i)if(m_buf[i].show)m_showline.push_back(i);
	return;
}

bool ListBoxWnd::Buffer::SetShow(intptr_t line,bool show){
	if(line < 0 || line >= GetLineCount())return false;
	if(m_buf[line].show == show)return true;
	m_buf[line].show = show;
	if(show){
		if(m_showline.empty() || m_showline.back() < line)m_showline.push_back(line);
		else{
			m_showline.push_back(m_showline.back());
			intptr_t i;
			for(i = GetLineCount() - 2 ; line < m_showline[i] && i >= 0 ; --i){
				m_showline[i] = m_showline[i - 1];
			}
			m_showline[i] = line;
		}
	}else{
		intptr_t i;
		for(i = GetLineCount() - 1 ; i >= 0 && m_showline[i] != line; --i);
		m_showline.erase(m_showline.begin() + i);
	}
	return true;
}