#include "stdafx.h"
#include "Monitor.h"

intptr_t Monitor::GetMonitorFromPoint(intptr_t x, intptr_t y){
	POINT pt;pt.x = (LONG)x;pt.y = (LONG)y;
	HMONITOR mon = ::MonitorFromPoint(pt,MONITOR_DEFAULTTONULL);
	if(mon == NULL){::SetmacrodllLastError();return 0;}
	m_hmonitor.push_back(mon);
	return m_hmonitor.size();
}

bool Monitor::GetMonitorInfoByHandle(intptr_t handle,MONITORINFO *mi){
	if(handle <= 0 || handle > static_cast<int>(m_hmonitor.size()) || m_hmonitor[handle - 1] == NULL){
		::SetmacrodllLastError(_T("Lȃnhł͂܂D"));
		return false;
	}
	mi->cbSize = sizeof(MONITORINFO);
	if(::GetMonitorInfo(m_hmonitor[handle - 1],mi) == 0){
		::SetmacrodllLastError();
		return false;
	}else return true;
}

intptr_t Monitor::GetMonitorX(intptr_t handle){
	MONITORINFO mi;
	if(!GetMonitorInfoByHandle(handle,&mi))return -1;
	else return mi.rcMonitor.left;
}

intptr_t Monitor::GetMonitorY(intptr_t handle){
	MONITORINFO mi;
	if(!GetMonitorInfoByHandle(handle,&mi))return -1;
	else return mi.rcMonitor.top;
}

intptr_t Monitor::GetMonitorHeight(intptr_t handle){
	MONITORINFO mi;
	if(!GetMonitorInfoByHandle(handle,&mi))return -1;
	else return mi.rcMonitor.bottom - mi.rcMonitor.top;
}

intptr_t Monitor::GetMonitorWidth(intptr_t handle){
	MONITORINFO mi;
	if(!GetMonitorInfoByHandle(handle,&mi))return -1;
	else return mi.rcMonitor.right - mi.rcMonitor.left;
}
