#pragma once

#include<map>

namespace PEGspace{
	class PEGImpl;
}

class PEG{
public:
	PEG(){}
	~PEG();

	intptr_t NewSyntax(const wchar_t *name, const wchar_t *base);
	intptr_t SetRule(const wchar_t *name, const wchar_t *rulename, const wchar_t *def);
	intptr_t SetSkip(const wchar_t *name, const wchar_t *def);
	intptr_t Match(const wchar_t *name, const wchar_t *str);
	intptr_t GetLastMatchPos(const wchar_t *name);
	intptr_t GetLastMatchLen(const wchar_t *name);
	intptr_t GetLastMatchPos(const wchar_t *name, const wchar_t *tag);
	intptr_t GetLastMatchLen(const wchar_t *name, const wchar_t *tag);
	intptr_t Parse(const wchar_t *name, const wchar_t *str);
	const wchar_t *Execute(const wchar_t *name);
	const wchar_t *GetValue(const wchar_t *name, intptr_t n);
	intptr_t SetValue(const wchar_t *name, const wchar_t *val);
	
private:
	std::map<ablib::wstring, PEGspace::PEGImpl*> m_grammars;

};

