#include "stdafx.h"
#include <ablib/IsKanji.h>
#include "TextWindow.h"

intptr_t TextWindow::Create(HWND hwnd, intptr_t x, intptr_t y, const TCHAR *text){
	if(text && ::IsBadStringPtr(text,1) != FALSE){
		SetmacrodllLastError(_T("|C^Ół͂܂D"));
		return FALSE;
	}
	if(text)m_text = Escape(text);
	m_x = x;m_y = y;

	m_parent = hwnd;
	HWND me = CWindowImpl::Create(hwnd,NULL,NULL,WS_BORDER | WS_VISIBLE | WS_POPUP);
	if(!me){::SetmacrodllLastError();return FALSE;}

	if(m_isshow)::ShowWindow(me,SW_SHOW);
	::SetActiveWindow(hwnd);
	Update();
	return TRUE;
}


LRESULT TextWindow::OnCreate(LPCREATESTRUCT lpCreateStruct){
	SetCFont();
	return 0;
}

// \\\ɁC\*\n*ɁDisR[hj
ablib::string TextWindow::Escape(const TCHAR *str){
	TCHAR tmp[3];tmp[0] = '\n';tmp[2] = '\0';
	ablib::string rv;
	int len = ::lstrlen(str);
	rv.reserve(len);
	ablib::string::size_type p = 0;
	for(int i = 0 ; i < len ; ++i){
		if(str[i] == '\\'){
			rv.append(str,p,i - p);
			++i;
			if(str[i] == 'n' || str[i] == 'B' || str[i] == 'E'){
				p = i + 1;
				tmp[1] = str[i];
				rv += tmp;
			}else if(str[i] == '\\'){
				p = i + 1;
				rv += _T("\\");
#ifndef UNICODE
			}else if(ablib::IsKanji(str[i])){
				p = i;
				++i;
#endif
			}else{
				p = i;
				rv += str[i];
			}
		// ʏ̉sR[hD
		}else if(str[i] == '\n'){
			rv.append(str,p,i - p);
			p = i + 1;
			tmp[1] = 'n';
			rv += tmp;
#ifndef UNICODE
		}else if(ablib::IsKanji(str[i])){
			++i;
#endif
		}
	}
	rv.append(str,p,ablib::string::npos);
	return rv;
}

void TextWindow::SetCFont(){
	if(!::IsWindow(m_hWnd))return;
	WTL::CDC dc(::GetDC(m_hWnd));
	// ̂CreatePointFontłtmHeight = 2ƂȂtHgłDCreateFontIndirectH
//	m_font.CreatePointFont(m_fontsize,m_fontname.c_str());
	m_font = ::CreateFont((int)m_fontsize,0,0,0,0,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,PROOF_QUALITY,FIXED_PITCH |FF_MODERN ,m_fontname.c_str());
//	m_boldfont.CreatePointFont(m_fontsize,m_fontname.c_str(),dc,true);
	m_boldfont = ::CreateFont((int)m_fontsize,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,PROOF_QUALITY,FIXED_PITCH |FF_MODERN ,m_fontname.c_str());
	HFONT oldfont = dc.SelectFont(m_font);
	dc.GetTextMetrics(&m_fontdata);
	dc.SelectFont(oldfont);

	dc.SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));
	dc.SetBkColor(GetSysColor(COLOR_WINDOW));
}

void TextWindow::OnPaint(HDC){
	WTL::CPaintDC dc(m_hWnd);
	RECT rc;
	::GetClientRect(m_hWnd,&rc);
	dc.FillRect(&rc,::GetSysColorBrush(COLOR_WINDOW));
	HWND active = ::GetActiveWindow();

	if(!m_isshow){
		if(::IsWindowVisible(m_hWnd)){
			::ShowWindow(m_hWnd,SW_HIDE);
			::SetActiveWindow(m_parent);
		}
		return;
	}else{
		if(!::IsWindowVisible(m_hWnd)){
			::ShowWindow(m_hWnd,SW_SHOW);
			::SetActiveWindow(m_parent);
		}
	}

	intptr_t maxlen = 0;
	intptr_t line = 0;
	CalcDrawText(dc,true,maxlen,line);

	::GetWindowRect(m_hWnd,&rc);
	if(m_height < 0 || m_width < 0){
		::MoveWindow(m_hWnd, (int)m_x,(int)m_y,(int)(maxlen + 8), (int)((line + 1)*(3 + m_fontdata.tmHeight)),TRUE);
		::SetActiveWindow(active);
	}else{
		::MoveWindow(m_hWnd, (int)m_x, (int)m_y, (int)m_width, (int)m_height,TRUE);
		::SetActiveWindow(active);
	}
}

void TextWindow::OnDestroy(){
	m_font.DeleteObject();
	m_boldfont.DeleteObject();
//	::PostQuitMessage(0);
}

void TextWindow::CalcDrawText(WTL::CDC &dc,bool draw, intptr_t &width, intptr_t &line){
	ablib::string::size_type p = 0, q = 0;
	width = 0;line = 0;
	intptr_t textwidth = 0;// 񒷂
	SIZE size;
	RECT rc;
	HFONT oldfont = dc.SelectFont(m_font);
	while(true){
		p = m_text.find(_T("\n"),q);
		if(p == ablib::string::npos){
			rc.left = 2 + (int)textwidth;rc.top = (int)(1 + (3 + m_fontdata.tmHeight)*line);
			if(draw)dc.DrawText(m_text.c_str() + q, (int)(m_text.length() - q),&rc,DT_NOCLIP);
			dc.GetTextExtent(m_text.c_str() + q, (int)(m_text.length() - q),&size);
			textwidth += size.cx;
			width = Max(textwidth,width);
			break;
		}
		rc.left = (int)(2 + textwidth);rc.top = (int)(1 + (3 + m_fontdata.tmHeight)*line);
		if(draw)dc.DrawText(m_text.c_str() + q, (int)(p - q),&rc,DT_NOCLIP);
		if(dc.GetTextExtent(m_text.c_str() + q, (int)(p - q),&size))textwidth += size.cx;
		else textwidth += m_fontdata.tmAveCharWidth*(p - q);
		++p;
		switch(m_text[p]){
		case 'n':
			width = Max(width,textwidth);
			textwidth = 0;
			++line;++p;
			break;
		case 'B':
			dc.SelectFont(m_boldfont);
			++p;
			break;
		case 'E':
			dc.SelectFont(m_font);
			++p;
			break;
		default:
			break;
		}
		q = p;
	}
	dc.SelectFont(oldfont);
}

intptr_t TextWindow::Update(){
	if(!::IsWindow(m_hWnd))return FALSE;
	HWND active = ::GetActiveWindow();
	if(m_isshow){
		::ShowWindow(m_hWnd,SW_SHOW);
		if(m_height >= 0 || m_width >= 0){
			::MoveWindow(m_hWnd, (int)m_x, (int)m_y, (int)m_width, (int)m_height,TRUE);
		}else{
			intptr_t width,line;
			WTL::CDC dc(::GetDC(m_hWnd));
			CalcDrawText(dc,false,width,line);
			::MoveWindow(m_hWnd, (int)m_x, (int)m_y, (int)(width + 8), (int)((line + 1)*(3 + m_fontdata.tmHeight)),TRUE);
		}
	}else ::ShowWindow(m_hWnd,SW_HIDE);
	::InvalidateRect(m_hWnd,NULL,TRUE);
	::SetActiveWindow(active);
	return TRUE;
}

intptr_t TextWindow::GetWindowHeight(){
	if(m_height >= 0 || m_width >= 0)return m_height;
	else{
		intptr_t width,line;
		WTL::CDC dc(::GetDC(m_hWnd));
		CalcDrawText(dc,false,width,line);
		return (line+1)*(3 + m_fontdata.tmHeight);
	}
}

intptr_t TextWindow::GetWindowWidth(){
	if(m_height >= 0 || m_width >= 0)return m_width;
	else{
		intptr_t width,line;
		WTL::CDC dc(::GetDC(m_hWnd));
		CalcDrawText(dc,false,width,line);
		return width + 8;
	}
}

