#include "stdafx.h"
#include "window.h"

extern ablib::string tmp_string;

intptr_t Window::GetCaretPosX(HWND hwnd,const TCHAR *wclass){
	HWND client = NULL;
	if(wclass){if(EnumWindow(wclass,hwnd) > 0)client = GetEnumWindows(0);}
	else client = hwnd;
	if(!client)return -1;
	POINT pt;
	::GetCaretPos(&pt);
	::ClientToScreen(client,&pt);
	return pt.x;
}

intptr_t Window::GetCaretPosY(HWND hwnd,const TCHAR *wclass){
	HWND client = NULL;
	if(wclass){if(EnumWindow(wclass,hwnd) > 0)client = GetEnumWindows(0);}
	else client = hwnd;
	if(!client)return -1;
	POINT pt;
	::GetCaretPos(&pt);
	::ClientToScreen(client,&pt);
	return pt.y;
}

intptr_t Window::GetFontWidth(HWND hwnd,const TCHAR *wclass){
	HWND client = NULL;
	if(wclass){if(EnumWindow(wclass,hwnd) > 0)client = GetEnumWindows(0);}
	else client = hwnd;
	if(!client)return -1;
	TEXTMETRIC tm;
	HDC hdc = ::GetDC(client);
	::GetTextMetrics(hdc,&tm);
	::ReleaseDC(client,hdc);
	return tm.tmAveCharWidth;
}

intptr_t Window::GetFontHeight(HWND hwnd,const TCHAR *wclass){
	HWND client = NULL;
	if(wclass){if(EnumWindow(wclass,hwnd) > 0)client = GetEnumWindows(0);}
	else client = hwnd;
	if(!client)return -1;
	TEXTMETRIC tm;
	HDC hdc = ::GetDC(client);
	::GetTextMetrics(hdc,&tm);
	::ReleaseDC(client,hdc);
	return tm.tmHeight;
}

intptr_t Window::ClientToScreenX(HWND hwnd, const TCHAR *wclass, intptr_t x, intptr_t y) {
	HWND client = NULL;
	if (wclass) { if (EnumWindow(wclass, hwnd) > 0)client = GetEnumWindows(0); } else client = hwnd;
	if (!client)return -1;
	POINT pt; pt.x = (int)x; pt.y = (int)y;
	::ClientToScreen(client, &pt);
	return pt.x;
}

intptr_t Window::ClientToScreenY(HWND hwnd,const TCHAR *wclass, intptr_t x, intptr_t y){
	HWND client = NULL;
	if(wclass){if(EnumWindow(wclass,hwnd) > 0)client = GetEnumWindows(0);}
	else client = hwnd;
	if(!client)return -1;
	POINT pt;pt.x = (int)x;pt.y = (int)y;
	::ClientToScreen(client,&pt);
	return pt.y;
}

const TCHAR *Window::GetWindowText(HWND hwnd){
	TCHAR buf[4096];
	::GetWindowText(hwnd,buf,4095);
	tmp_string = buf;
	return tmp_string.c_str();
}

intptr_t Window::SetActiveWindow(HWND hwnd){
	::ShowWindow(hwnd,SW_RESTORE);
	return ::SetWindowPos(hwnd,HWND_TOP,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
}

HWND Window::GetActiveWindow(){
	return ::GetActiveWindow();
}

intptr_t Window::EnumWindow(const TCHAR *wclass,HWND hwnd){
	if(!m_enumwreg.Compile(wclass))return -1;
	m_windows.clear();
	if(hwnd == NULL){
		if(::EnumWindows(sEnumWindowsProc,reinterpret_cast<LPARAM>(this)) == FALSE)return -1;
	}else{
		if(::EnumChildWindows(hwnd,sEnumWindowsProc,reinterpret_cast<LPARAM>(this)) == FALSE)return -1;
	}
	return m_windows.size();
}

BOOL CALLBACK Window::sEnumWindowsProc(HWND hwnd,LPARAM lParam){
	return reinterpret_cast<Window*>(lParam)->EnumWindowsProc(hwnd);
}

BOOL Window::EnumWindowsProc(HWND hwnd){
	TCHAR buf[4096];
	::GetClassName(hwnd,buf,4095);
	if(m_enumwreg.Match(buf))m_windows.push_back(hwnd);
	return TRUE;
}

intptr_t Window::GetWindowLeft(HWND hwnd){
	RECT r;
	if(!::GetWindowRect(hwnd,&r))return 0;
	else return r.left;
}

intptr_t Window::GetWindowRight(HWND hwnd){
	RECT r;
	if(!::GetWindowRect(hwnd,&r))return 0;
	else return r.right;
}

intptr_t Window::GetWindowTop(HWND hwnd){
	RECT r;
	if(!::GetWindowRect(hwnd,&r))return 0;
	else return r.top;
}

intptr_t Window::GetWindowBottom(HWND hwnd){
	RECT r;
	if(!::GetWindowRect(hwnd,&r))return 0;
	else return r.bottom;
}

const TCHAR *Window::GetClassName(HWND hwnd){
	TCHAR buf[1024];
	HWND target = hwnd;
	tmp_string = _T("");
	while(target){
		if(!::GetClassName(target,buf,1023))return _T("");
		tmp_string = ablib::string(buf) + _T("\n") + tmp_string;
		target = ::GetParent(target);
	}
	if(tmp_string != _T(""))tmp_string.erase(tmp_string.length() - 1);
	return tmp_string.c_str();
}

/*
const TCHAR *Window::GetExecFileName(HWND hwnd){
	HANDLE handle = ::OpenProcess(PROCESS_ALL_ACCESS,FALSE,::GetWindowThreadProcessId(hwnd,NULL));
	if(!handle)return _T("");
	HMODULE hmodule = reinterpret_cast<HMODULE>(::GetWindowLong(hwnd,GWL_HINSTANCE));
	static TCHAR buf[4096];
	if(!::GetModuleFileName(hmodule,buf,4095))return _T("");
	return buf;

}
*/