﻿#ifndef NDEBUG
#ifndef _CRTDBG_MAP_ALLOC
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>
#endif
#endif

#include "../stdafx.h"
#include <windows.h>
#include <tchar.h>
#include <ablib/string.h>
#include <ablib/lexical_cast.h>


//コピー禁止
#define NOCOPY(T) T( const T& ); T& operator=( const T& )

//あさーと
#ifndef ASSERT
	#ifdef NDEBUG
		#define ASSERT(C)
	#else
		#include <assert.h>
		#define ASSERT(C) assert(C)
	#endif
#endif

//でばぐ用
#ifndef __DEBUGSTRING__
	#define __DEBUGSTRING__
	#ifdef NDEBUG
		inline void DEBUGSTRING(const char *fmt,...){}
	#else
		#include <stdarg.h>
		inline void DEBUGSTRING(const char *fmt,...){
			char buf[4096];
			va_list args;
			va_start(args,fmt);
			::wvsprintf(buf,fmt,args);
			::OutputDebugString(buf);
			::OutputDebugString(_T("\n"));
			va_end(args);
		}
	#endif
#endif


class DLL{
private:
	typedef const void *PARAM;

	typedef char* (*CHARFUNC)(
		PARAM para1 ,PARAM para2 ,PARAM para3 ,PARAM para4 ,PARAM para5 ,
		PARAM para6 ,PARAM para7 ,PARAM para8 ,PARAM para9 ,PARAM para10,
		PARAM para11,PARAM para12,PARAM para13,PARAM para14,PARAM para15,
		PARAM para16,PARAM para17,PARAM para18,PARAM para19,PARAM para20
		);
	typedef wchar_t* (*WCHARFUNC)(
		PARAM para1, PARAM para2, PARAM para3, PARAM para4, PARAM para5,
		PARAM para6, PARAM para7, PARAM para8, PARAM para9, PARAM para10,
		PARAM para11, PARAM para12, PARAM para13, PARAM para14, PARAM para15,
		PARAM para16, PARAM para17, PARAM para18, PARAM para19, PARAM para20
		);

	typedef int (*INTFUNC)(
		PARAM para1 ,PARAM para2 ,PARAM para3 ,PARAM para4 ,PARAM para5 ,
		PARAM para6 ,PARAM para7 ,PARAM para8 ,PARAM para9 ,PARAM para10,
		PARAM para11,PARAM para12,PARAM para13,PARAM para14,PARAM para15,
		PARAM para16,PARAM para17,PARAM para18,PARAM para19,PARAM para20
		);

	/** ここで全てPARAM = void*に変換する．
	*/
	struct DllParam{
		DllParam(intptr_t n){val = reinterpret_cast<PARAM>(n);}
		DllParam(int n) { val = reinterpret_cast<PARAM>(n); }
		DllParam(PARAM p){val = p;}
		DllParam(HWND hwnd){val = reinterpret_cast<PARAM>(hwnd);}
		DllParam(bool b){val = reinterpret_cast<PARAM>(b?TRUE:FALSE);}
		operator PARAM(){return val;}
		PARAM val;
	};

public:
	DLL(void) : m_dll(NULL){};
	~DLL(void){freedll();}
	bool loaddll(const char *dllname){
		if(m_dll)return false;
		m_dll = ::LoadLibrary(dllname);
		return (m_dll != NULL);
	}

	const char *dllfuncstr(const  char *funcname,
		DllParam p1  = 0,DllParam p2  = 0,DllParam p3  = 0,DllParam p4  = 0,DllParam p5  = 0,
		DllParam p6  = 0,DllParam p7  = 0,DllParam p8  = 0,DllParam p9  = 0,DllParam p10 = 0,
		DllParam p11 = 0,DllParam p12 = 0,DllParam p13 = 0,DllParam p14 = 0,DllParam p15 = 0,
		DllParam p16 = 0,DllParam p17 = 0,DllParam p18 = 0,DllParam p19 = 0,DllParam p20 = 0
		){
		if(m_dll == NULL)return NULL;
		CHARFUNC func = reinterpret_cast<CHARFUNC>(::GetProcAddress(m_dll,funcname));

		if(func){
			static ablib::string rv;
			rv = func(p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20);
			DEBUGSTRING(_T("DLL : %sを呼び出し．戻り値：%s"), funcname, rv.c_str());
			return rv.c_str();
		}else{
			char buf[1024];
			::wsprintf(buf,_T("%sが見つかりません．"),funcname);
			::OutputDebugString(buf);
			return _T("");
		}
	}

	const wchar_t *dllfuncstr(const  wchar_t *funcname,
		DllParam p1 = 0, DllParam p2 = 0, DllParam p3 = 0, DllParam p4 = 0, DllParam p5 = 0,
		DllParam p6 = 0, DllParam p7 = 0, DllParam p8 = 0, DllParam p9 = 0, DllParam p10 = 0,
		DllParam p11 = 0, DllParam p12 = 0, DllParam p13 = 0, DllParam p14 = 0, DllParam p15 = 0,
		DllParam p16 = 0, DllParam p17 = 0, DllParam p18 = 0, DllParam p19 = 0, DllParam p20 = 0
		){
		if(m_dll == NULL)return NULL;
		WCHARFUNC func = reinterpret_cast<WCHARFUNC>(::GetProcAddress(m_dll, ablib::TransCode::Trans(funcname).c_str()));

		if(func){
			static ablib::wstring rv;
			rv = func(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16, p17, p18, p19, p20);
			DEBUGSTRINGW(L"DLL : %sを呼び出し．戻り値：%s", funcname, rv.c_str());
			return rv.c_str();
		} else{
			DEBUGSTRINGW(L"%s が見つかりません．", funcname);
			return L"";
		}
	}

	int dllfunc(const wchar_t *funcname,
		DllParam p1 = 0, DllParam p2 = 0, DllParam p3 = 0, DllParam p4 = 0, DllParam p5 = 0,
		DllParam p6 = 0, DllParam p7 = 0, DllParam p8 = 0, DllParam p9 = 0, DllParam p10 = 0,
		DllParam p11 = 0, DllParam p12 = 0, DllParam p13 = 0, DllParam p14 = 0, DllParam p15 = 0,
		DllParam p16 = 0, DllParam p17 = 0, DllParam p18 = 0, DllParam p19 = 0, DllParam p20 = 0
		){
		return dllfunc(ablib::TransCode::Trans(funcname).c_str(), p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16, p17, p18, p19, p20);
	}
	int dllfunc(const char *funcname,
		DllParam p1  = 0,DllParam p2  = 0,DllParam p3  = 0,DllParam p4  = 0,DllParam p5  = 0,
		DllParam p6  = 0,DllParam p7  = 0,DllParam p8  = 0,DllParam p9  = 0,DllParam p10 = 0,
		DllParam p11 = 0,DllParam p12 = 0,DllParam p13 = 0,DllParam p14 = 0,DllParam p15 = 0,
		DllParam p16 = 0,DllParam p17 = 0,DllParam p18 = 0,DllParam p19 = 0,DllParam p20 = 0
		){
		if(m_dll == NULL)return 0;
		INTFUNC func = reinterpret_cast<INTFUNC>(::GetProcAddress(m_dll,funcname));

		if (func) {
			int rv = func(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16, p17, p18, p19, p20);
			DEBUGSTRING(_T("DLL : %sを呼び出し．戻り値：%d"), funcname,rv);
			return rv;
		} else {
			char buf[1024];
			::wsprintf(buf,_T("%sが見つかりません．"),funcname);
			::OutputDebugString(buf);
			return 0;
		}
	}

	bool freedll(){
		if(m_dll = NULL)return false;
		if(!::FreeLibrary(m_dll))return false;
		m_dll = NULL;
		return true;
	}


private:
	HMODULE m_dll;

private:
	NOCOPY(DLL);
};



#ifdef NDEBUG
const char path[] = _T("C:\\Users\\Abe_Noriyuki\\Documents\\vs\\macrodll\\x64\\release\\macrodll.dll");
#else
//const char path[] = _T(".\\x64\\Debug\\macrodll.dll");
const char path[] = _T("C:\\Users\\Abe_Noriyuki\\Documents\\vs\\macrodll\\x64\\debug\\macrodll.dll");

#endif
const char file[] = _T("c:\\tmp\\test.tex");
//const char hmjre[] = _T("c:\\program files (x86)\\hidemaru\\hmjre.dll");
const char hmjre[] = _T("c:\\program files\\hidemaru\\hmjre.dll");

#include <hmjre_dll/RegEx.h>
#include <hmjre_dll/JREUSR.H>
#include <string>
#include <boost/lexical_cast.hpp>

int toint(const std::string &a){
	if(a == _T(""))return 0;
	else return boost::lexical_cast<int>(a);
}
/*
#include <boost/spirit/include/qi.hpp>
#include <boost/spirit/include/qi_char.hpp>
#include <boost/spirit/include/qi_grammar.hpp>
#include <boost/spirit/include/phoenix.hpp>
*/
std::wstring Output(const std::wstring &str){
	::OutputDebugStringW((L"output: " + str + L"\n").c_str());
	return str;
}
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow){
	/*
	using namespace boost::spirit;
	using namespace boost::spirit::standard_wide;
	boost::spirit::qi::rule<const wchar_t*,std::wstring()> r,rr;
	r = char_(L"a");
	const wchar_t *s = L"ab";
	const wchar_t *start = s;
	const wchar_t *end = s + ::lstrlenW(s);
	std::wstring result;
	DEBUGSTRING("%s", qi::parse(start, end, r, result) ? "true" : "false");
	DEBUGSTRING("%d", end - start);
	*/

#ifndef NDEBUG
	::_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
#endif
	HmJre::SetDLLName(hmjre);
	DLL dll;
	dll.loaddll(path);
	dll.dllfunc("SETHMJREDLL",hmjre);
	char currentdir[4096];
	::GetCurrentDirectory(4095,currentdir);

	dll.dllfunc("COMPILE_SETSIZE", 500, 500);
	dll.dllfunc("COMPILE_SETPOS", 0, 0);
	dll.dllfunc("COMPILE_SETFONT", "FixedSys", 11);
	dll.dllfunc("COMPILE_SETCOLOR", 0,0xFFFFFF);
	dll.dllfunc("COMPILE_START", 0, "cmd /k", currentdir);
	auto x = dll.dllfuncstr("GETLASTERROR");
	return 0;

	dll.dllfunc("ANALYZE_START", "C:\\Users\\Abe_Noriyuki\\Documents\\articles\\test\\test.tex");
	//auto y = dll.dllfunc("COMPILE_START", 0, "platex test.tex", "C:\\Users\\Abe_Noriyuki\\Documents\\articles\\test");
	dll.dllfunc("ANALYZE_NEXT");


	/*dll.dllfunc("COLLECTSTR_COLLECT",
		"c:\\users\\abe_noriyuki\\documents\\hidemaru\\macros\\fortex\\log\\Abe_Noriyuki\\texlog.log",
		"!(Double subscript | Double superscript | Undefined control sequence)\\.\n(<recently read>.*\n.*\n) ? (l\\.[0 - 9] + ) ? (<[a - zA - Z] * >) ? (.*\\.) ? \\ ? *(.*)\n *(.* ? )(\\.\\.\\.) ? \n",
		"\\1\n\\6\n\\7");
*/
	dll.freedll();
	return 0;
}

