#include "stdafx.h"
#include <algorithm>
#include <window/Graphic.h>
#include <ablib/SmallVector.h>
#include "listboxwnd.h"

extern HINSTANCE g_dllint;

TCHAR        WindowClassName[] = _T("ForTeXListBox");
TCHAR CommentWindowClassName[] = _T("ForTeXListBoxComment");

ListBoxWnd::ListBoxWnd() : m_isshow(false),
m_hsize(200),m_vsize(6),m_parent(NULL),m_comwnd(&m_buf)
{
}

ListBoxWnd::CommentWnd::CommentWnd(Buffer *buf) : m_buf(buf){}

HWND ListBoxWnd::Create(HWND hwnd,int x,int y,HINSTANCE appint,bool comment,bool commentfix){
	m_buf.m_issel = false;
	m_buf.m_selindex = 0;
	m_parent = hwnd;

	HWND me = CScrollWindowImpl::Create(hwnd,NULL,NULL,WS_POPUP | WS_BORDER | WS_VSCROLL | WS_VISIBLE);
	if(!me)return NULL;
	if(m_isshow)::ShowWindow(me,SW_SHOW);
	::SetActiveWindow(hwnd);
	::MoveWindow(me,x,y,1,1,TRUE);

	if(comment){
		m_comment = true;
		m_comwnd.m_commentfix = commentfix;
		m_comwnd.Create(m_parent);
	}else m_comment = false;
	Update();
	return me;
}


LRESULT ListBoxWnd::OnCreate(LPCREATESTRUCT lpCreateStruct){
//	m_font.CreatePointFont(m_fontsize,m_fontname.c_str());
	m_font = ::CreateFont(m_fontsize,0,0,0,0,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,PROOF_QUALITY,FIXED_PITCH |FF_MODERN ,m_fontname.c_str());
	WTL::CDC dc(::GetDC(m_hWnd));
	HFONT oldfont = dc.SelectFont(m_font);
	dc.GetTextMetrics(&m_fontdata);
	dc.SelectFont(oldfont);

	dc.SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));
	dc.SetBkColor(::GetSysColor(COLOR_WINDOW));

	m_dotpen.CreatePen(PS_DOT,1,::GetSysColor(COLOR_WINDOWTEXT));
	m_comwnd.SetShow(m_isshow);
	m_comwnd.SetListWnd(m_hWnd);
	return true;
}

void ListBoxWnd::OnDestroy(){
	m_font.DeleteObject();
	m_dotpen.DeleteObject();
	if(m_comwnd.m_hWnd)::DestroyWindow(m_comwnd.m_hWnd);
}


void ListBoxWnd::SetScroll(int pos){
	SCROLLINFO si;
	::ZeroMemory(&si,sizeof(SCROLLINFO));
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_ALL;
	::GetScrollInfo(m_hWnd,SB_VERT,&si);
	int oldpos = si.nPos;

	si.nPage = m_vsize;
	si.nMin = 0;si.nMax = m_buf.GetShowCount() - 1;
	si.nPos = pos;
	::SetScrollInfo(m_hWnd,SB_VERT,&si,TRUE);
	if(si.nPos != oldpos){
		::ScrollWindowEx(m_hWnd,0,TextHeight() * (oldpos - si.nPos),NULL,NULL,NULL,NULL,SW_INVALIDATE);
		if(m_comment)::InvalidateRect(m_comwnd,NULL,TRUE);
	}
	return;
}

//Xg`
void ListBoxWnd::OnPaint(HDC /*hDC*/){
	WTL::CPaintDC dc(m_hWnd);
	if(!m_isshow){
		if(!::IsWindowVisible(m_hWnd)){
			::ShowWindow(m_hWnd,SW_HIDE);
			::SetActiveWindow(m_parent);
		}
	}else{
		if(!::IsWindowVisible(m_hWnd)){
			::ShowWindow(m_hWnd,SW_SHOW);
			::SetActiveWindow(m_parent);
		}
	}

	WTL::CScrollBar scrbar = m_hWnd;
	// WTL̂@킩ȂD
	SCROLLINFO si;
	::ZeroMemory(&si,sizeof(SCROLLINFO));
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_ALL;
	::GetScrollInfo(m_hWnd,SB_VERT,&si);
	int scroll = si.nPos;
	int line = dc.m_ps.rcPaint.top / TextHeight();
	CRect rc;rc.left = 0;rc.top = line * TextHeight();rc.right = m_hsize;rc.bottom = m_vsize * TextHeight() + 4;
	dc.FillRect(&rc,COLOR_WINDOW);

	ablib::string text;
	HFONT oldfont = dc.SelectFont(m_font);
	for(; line < m_vsize ; ++line){
		if(!m_buf.GetShowStr(line + scroll,text))break;
		rc.left = 2;rc.top = 2 + line*TextHeight();
		if(line + scroll == m_buf.m_selindex){
			if(m_buf.m_issel){
				dc.SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
				dc.SetBkColor(::GetSysColor(COLOR_HIGHLIGHT));
				rc.left = 0;rc.top = line * TextHeight();rc.right = m_hsize - 1;rc.bottom = (line + 1)*TextHeight();
				dc.FillRect(&rc,COLOR_HIGHLIGHT);
				dc.DrawText(text.c_str(),text.length(),&rc,DT_NOCLIP);
				dc.SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));
				dc.SetBkColor(::GetSysColor(COLOR_WINDOW));
			}else{
				dc.DrawText(text.c_str(),text.length(),&rc,DT_NOCLIP);
				HPEN oldpen = dc.SelectPen(m_dotpen);
				dc.MoveTo(0,line*TextHeight());
				dc.LineTo(m_hsize - 1,line*TextHeight());
				dc.LineTo(m_hsize - 1,(line + 1)*TextHeight());
				dc.LineTo(0,(line + 1) * TextHeight());
				dc.LineTo(0,line * TextHeight());
				dc.SelectPen(oldpen);
			}
		}else{
			dc.DrawText(text.c_str(),text.length(),&rc,DT_NOCLIP);
		}
	}
	if(m_comwnd.m_hWnd)m_comwnd.OnPaint();
	dc.SelectFont(oldfont);
}

//XN[
void ListBoxWnd::OnVScroll(int nSBCode, short nPos, HWND hWnd){
	// WTL̂@킩ȂD
	SCROLLINFO si;
	::ZeroMemory(&si,sizeof(SCROLLINFO));
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_ALL;
	::GetScrollInfo(hWnd,SB_VERT,&si);
	int dy;
	switch(nSBCode){
	case SB_LINEUP:		dy = -1;
	case SB_LINEDOWN:	dy = 1;
	case SB_PAGEUP:		dy = -static_cast<int>(si.nPage);
	case SB_PAGEDOWN:	dy = si.nPage;
	case SB_TOP:		dy = si.nMin - si.nPos;
	case SB_BOTTOM:		dy = si.nMax - si.nPos;
	case SB_THUMBTRACK:	dy = si.nTrackPos - si.nPos;
	default: dy = 0;
	}
	SetScroll(si.nPos + dy);
	return;
}


//}EX
void ListBoxWnd::OnLButtonDown(UINT nFlags, WTL::CPoint point){
	if(m_buf.GetLineCount() == 0)return;
	SCROLLINFO si;
	::ZeroMemory(&si,sizeof(SCROLLINFO));
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_ALL;
	::GetScrollInfo(m_hWnd,SB_VERT,&si);
	m_buf.m_selindex = si.nPos + point.y / TextHeight();
	m_buf.m_issel = true;
	::InvalidateRect(m_hWnd,NULL,TRUE);
	if(m_comment)::InvalidateRect(m_comwnd,NULL,TRUE);
}


LRESULT ListBoxWnd::CommentWnd::OnCreate(LPCREATESTRUCT lpCreateStruct){
	WTL::CDC dc(::GetDC(m_hWnd));
//	m_font.CreatePointFont(m_fontsize,m_fontname.c_str());
	m_font = ::CreateFont(m_fontsize,0,0,0,0,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,PROOF_QUALITY,FIXED_PITCH |FF_MODERN ,m_fontname.c_str());
//	m_boldfont.CreatePointFont(m_fontsize,m_fontname.c_str(),dc,true);
	m_boldfont = ::CreateFont(m_fontsize,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,PROOF_QUALITY,FIXED_PITCH |FF_MODERN ,m_fontname.c_str());
	HFONT oldfont = dc.SelectFont(m_font);
	dc.GetTextMetrics(&m_fontdata);
	dc.SelectFont(oldfont);

	dc.SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));
	dc.SetBkColor(GetSysColor(COLOR_WINDOW));
	return true;
}

//Rg`
void ListBoxWnd::CommentWnd::OnPaint(HDC){
	WTL::CPaintDC dc(m_hWnd);
	HWND active = ::GetActiveWindow();
	RECT rc;
	::GetClientRect(m_hWnd,&rc);
	dc.FillRect(&rc,::GetSysColorBrush(COLOR_WINDOW));

	ablib::string text;
	m_buf->GetShowComment(m_buf->m_selindex,text);
	if(!m_isshow ||
		(
		(!m_commentfix || !m_buf->GetFixedComment(text)) && 
		(!m_buf->m_issel || !m_buf->GetShowComment(m_buf->m_selindex,text) || text == _T(""))
		)
	){
		if(::IsWindowVisible(m_hWnd)){
			::ShowWindow(m_hWnd,SW_HIDE);
			::SetActiveWindow(active);
		}
		return;
	}else{
		if(!::IsWindowVisible(m_hWnd)){
			::ShowWindow(m_hWnd,SW_SHOW);
			::SetActiveWindow(active);
		}
	}
	HFONT oldfont = dc.SelectFont(m_font);

	ablib::string::size_type p = 0,q = 0;
	int maxlen = 0;
	int textwidth = 0;// 񒷂
	int line = 0;
	SIZE size;
	while(true){
		p = text.find(_T("\n"),q);
		if(p == ablib::string::npos){
			RECT rc;rc.left = 2 + textwidth;rc.top = 1 + (1 + TextHeight())*line;
			dc.DrawText(text.c_str() + q,text.length() - q,&rc,DT_NOCLIP);
			dc.GetTextExtent(text.c_str() + q,text.length() - q,&size);
			textwidth += size.cx;
			maxlen = Max(textwidth,maxlen);
			break;
		}
		dc.DrawText(text.c_str() + q,p - q,&rc,DT_NOCLIP);
		if(dc.GetTextExtent(text.c_str() + q,p - q,&size))textwidth += size.cx;
		else textwidth += m_fontdata.tmAveCharWidth*(p - q);
		++p;
		switch(text[p]){
		case 'n':
			maxlen = Max(maxlen,textwidth);
			textwidth = 0;
			++line;++p;
			break;
		case 'B':
			dc.SelectFont(m_boldfont);
			++p;
			break;
		case 'E':
			dc.SelectFont(m_font);
			++p;
			break;
		default:
			break;
		}
		q = p;
	}
	dc.SelectFont(oldfont);

	
	::GetWindowRect(m_listwnd,&rc);
	::MoveWindow(m_hWnd,rc.left,rc.bottom + 1,maxlen + 8,(TextHeight() + 1)*(line + 1),TRUE);
	::SetActiveWindow(active);
}

//ՂŁ[
bool ListBoxWnd::Update(){
	if(!::IsWindow(m_hWnd))return false;
	int pos = m_buf.m_selindex - m_vsize / 2;
	SetScroll(pos);
	ablib::window::Window active(::GetActiveWindow());
	if(m_isshow){
		::ShowWindow(m_hWnd,SW_SHOW);
		RECT rc;::GetWindowRect(m_hWnd,&rc);
		::MoveWindow(m_hWnd,rc.left,rc.top,m_hsize,m_vsize*TextHeight() + 2,TRUE);
		::UpdateWindow(m_hWnd);
	}else ::ShowWindow(m_hWnd,SW_HIDE);
	active.SetActive();
	::InvalidateRect(m_hWnd,NULL,TRUE);
	if(::IsWindow(m_comwnd))::InvalidateRect(m_comwnd,NULL,TRUE);
	RECT rc;::GetWindowRect(m_hWnd,&rc);
	return true;
}

//グI
bool ListBoxWnd::Up(int n,int sel){
	if(m_buf.GetLineCount() == 0)return false;
	int oldindex = m_buf.m_selindex;
	m_buf.m_selindex -= n;
	if(m_buf.m_selindex < 0)m_buf.m_selindex = 0;
	else if(m_buf.m_selindex >= m_buf.GetShowCount())m_buf.m_selindex = m_buf.GetShowCount() - 1;
	if(oldindex == m_buf.m_selindex && (sel?true:false) == m_buf.m_issel)return false;
	m_buf.m_issel = (sel ? true : false);

	SCROLLINFO si;
	::ZeroMemory(&si,sizeof(SCROLLINFO));
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_ALL;
	::GetScrollInfo(m_hWnd,SB_VERT,&si);

	if(m_buf.m_selindex >= si.nPos + m_vsize - 1)si.nPos = m_buf.m_selindex - m_vsize + 1;
	else if(m_buf.m_selindex < si.nPos)si.nPos = m_buf.m_selindex;
	SetScroll(si.nPos);
	::InvalidateRect(m_hWnd,NULL,TRUE);
	if(::IsWindow(m_comwnd))::InvalidateRect(m_comwnd,NULL,TRUE);
	return true;
}

int ListBoxWnd::SetFont(const TCHAR *fontname,int size){
	m_fontname = fontname;m_fontsize = size;
	if(::IsWindow(m_hWnd)){
		m_font.CreatePointFont(m_fontsize,m_fontname.c_str());
		WTL::CDC dc(::GetDC(m_hWnd));
		HFONT oldfont = dc.SelectFont(m_font);
		dc.GetTextMetrics(&m_fontdata);
		dc.SelectFont(oldfont);
	}
	m_comwnd.SetFont(m_fontname,m_fontsize);
	return TRUE;
}

void ListBoxWnd::CommentWnd::SetFont(const ablib::string &fontname,int fontsize){
	m_fontname = fontname;m_fontsize = fontsize;
	if(::IsWindow(m_hWnd)){
		WTL::CDC dc(::GetDC(m_hWnd));
		m_font.CreatePointFont(m_fontsize,m_fontname.c_str());
		m_boldfont.CreatePointFont(m_fontsize,m_fontname.c_str(),dc,true);
		HFONT oldfont = dc.SelectFont(m_font);
		dc.GetTextMetrics(&m_fontdata);
		dc.SelectFont(oldfont);
	}
}

//ȉobt@
bool ListBoxWnd::Buffer::InsertText(int line,const STRDATA &data){
	if(line < 0 || line > GetLineCount())return false;
	m_buf.insert(m_buf.begin() + line,data);
	if(data.show){
		if(m_showline.back() < line)m_showline.push_back(line);
		else{
			m_showline.push_back(m_showline.back());
			for(int i = GetShowCount() - 2 ; i >= 0 && m_showline[i] > line ; --i){
				m_showline[i - 1] = m_showline[i];
				m_showline[i] = line;
			}
		}
	}
	return true;
}

bool ListBoxWnd::Buffer::DeleteText(int line){
	if(line < 0 || line >= GetLineCount())return false;
	if(m_buf[line].show){
		int i;
		for(i = 0 ; i < GetShowCount() ; ++i)if(m_showline[i] == line)break;
		for(; i < GetShowCount() - 1; ++i)m_showline[i] = m_showline[i + 1];
		m_showline.pop_back();
	}
	for(int i = line ; i < GetLineCount() - 1; ++i)m_buf[i] = m_buf[i + 1];
	m_buf.pop_back();
	return true;
}

void ListBoxWnd::Buffer::AddText(const STRDATA &data){
	m_buf.push_back(data);
	if(data.show)m_showline.push_back(GetLineCount() - 1);
}

void ListBoxWnd::Buffer::ShowClear(){
	for(int i = 0 ; i < GetLineCount() ; ++i)m_buf[i].show = false;
	m_showline.clear();
}

void ListBoxWnd::Buffer::Sort(){
	std::sort(m_buf.begin(),m_buf.end());
	m_showline.clear();
	for(int i = 0 ; i < GetLineCount() ; ++i)if(m_buf[i].show)m_showline.push_back(i);
	return;
}

void ListBoxWnd::Buffer::Uniq(){
	std::sort(m_buf.begin(),m_buf.end());
	std::vector<STRDATA>::iterator p = std::unique(m_buf.begin(),m_buf.end());
	m_buf.erase(p,m_buf.end());
	m_showline.clear();
	for(int i = 0 ; i < GetLineCount() ; ++i)if(m_buf[i].show)m_showline.push_back(i);
	return;
}

bool ListBoxWnd::Buffer::SetShow(int line,bool show){
	if(line < 0 || line >= GetLineCount())return false;
	if(m_buf[line].show == show)return true;
	m_buf[line].show = show;
	if(show){
		if(m_showline.empty() || m_showline.back() < line)m_showline.push_back(line);
		else{
			m_showline.push_back(m_showline.back());
			int i;
			for(i = GetLineCount() - 2 ; line < m_showline[i] && i >= 0 ; --i){
				m_showline[i] = m_showline[i - 1];
			}
			m_showline[i] = line;
		}
	}else{
		int i;
		for(i = GetLineCount() - 1 ; i >= 0 && m_showline[i] != line; --i);
		m_showline.erase(m_showline.begin() + i);
	}
	return true;
}