#ifndef __LISTBOXWND_H__
#define __LISTBOXWND_H__

#include <vector>
#include <atlcrack.h>
#include <atlctrls.h>
#include <atlscrl.h>
#include <atlmisc.h>

/*
샊Xg{bNXD
̊ǗvectorNXsD

ꂵDR[hꂵD
*/

class ListBoxWnd : public CScrollWindowImpl<ListBoxWnd>{
private:
	class Buffer{
	public:
		struct STRDATA{
			STRDATA() : show(false){};
			STRDATA(const ablib::string &str,const ablib::string &comment,bool show) :
			str(str),comment(comment),show(show){};
			bool operator==(const STRDATA &obj) const{return (str == obj.str);}
			bool operator< (const STRDATA &obj) const{return (str <  obj.str);}
			bool operator> (const STRDATA &obj) const{return (str >  obj.str);}
			ablib::string str;
			ablib::string comment;
			bool show;
		};
	private:
		std::vector<STRDATA> m_buf;
		std::vector<int> m_showline;

	public:
		Buffer() : m_issel(false),m_selindex(0){};
		~Buffer(){};
		int GetLineCount() const{return m_buf.size();}
		int GetShowCount() const{return m_showline.size();}
		bool GetData(int line,STRDATA &data){if(line < 0 || line >= GetLineCount())return false;data = m_buf[line];return true;}
		bool GetStr(int line,ablib::string &str){if(line < 0 || line >= GetLineCount())return false;str = m_buf[line].str;return true;}
		bool GetComment(int line,ablib::string &str){if(line < 0 || line >= GetLineCount())return false;str = m_buf[line].comment;return true;}
		bool GetShowData(int line,STRDATA &data){if(line < 0 || line >= GetShowCount())return false;data = m_buf[m_showline[line]];return true;}
		bool GetShowStr(int line,ablib::string &str){if(line < 0 || line >= GetShowCount())return false;str = m_buf[m_showline[line]].str;return true;}
		bool GetShowComment(int line,ablib::string &str){if(line < 0 || line >= GetShowCount())return false;str = m_buf[m_showline[line]].comment;return true;}
		bool GetFixedComment(ablib::string &str){str = m_fixedcomment;return true;}
		bool InsertText(int line,const STRDATA &data);
		bool InsertText(int line,const ablib::string &str,const ablib::string &comment,bool show){InsertText(line,STRDATA(str,comment,show));}
		bool DeleteText(int line);
		void AddText(const STRDATA &data);
		void AddText(const ablib::string &str,const ablib::string &comment,bool show){AddText(STRDATA(str,comment,show));}
		void SetFixedComment(const ablib::string &str){m_fixedcomment = str;}
		void RemoveAll(){m_buf.clear();m_showline.clear();}
		void Sort();
		void Uniq();
		void ShowClear();
		bool SetShow(int line,bool show);

		typedef std::vector<STRDATA>::size_type size_type;
		int m_selindex;
		bool m_issel;
		ablib::string m_fixedcomment;
	}m_buf;
	
	typedef Buffer::size_type size_type;

public:
	DECLARE_WND_CLASS(_T("ForTeXListBox"));
	ListBoxWnd();
	~ListBoxWnd(){}
	HWND Create(HWND hwnd,int x,int y,HINSTANCE appint,bool comment = false,bool commentfix = false);
	void ShowClear(){m_buf.ShowClear();}
	void TextClear(){m_buf.RemoveAll();m_buf.m_selindex = 0;}
	void AddStr(const TCHAR *text,const TCHAR *comment = _T("")){m_buf.AddText(text,comment,true);}
	void AddStr(const ablib::string &text,const ablib::string &comment = _T("")){m_buf.AddText(text,comment,true);}
	void InsertText(int line,const TCHAR *text,const TCHAR *comment = _T("")){m_buf.InsertText(line,text,comment,true);}
	void SetFixedComment(const ablib::string &str){m_buf.SetFixedComment(str);}
	bool Update();
	bool SetShowStr(int line,bool show = true){return m_buf.SetShow(line,true);}
	void SetSize(int v,int h){m_vsize = v;m_hsize = h;}
	void SetPos(int x,int y){if(::IsWindow(m_hWnd))::MoveWindow(m_hWnd,x,y,0,0,FALSE);}
	bool SetSelect(int n,int sel){if(n < 0 || n >= m_buf.GetLineCount())return false;else{m_buf.m_selindex = n;if(sel)m_buf.m_issel = true;else m_buf.m_issel = false;return true;}}
	void SetShow(int show){if(show)m_isshow = true;else m_isshow = false;m_comwnd.SetShow(m_isshow);}
	void Sort(){m_buf.Sort();}
	void Uniq(){m_buf.Uniq();}
	int SetFont(const TCHAR *fontname,int size);
	bool Up(int n,int sel);

	const TCHAR *GetShowText(int n){static ablib::string rv;if(m_buf.GetShowStr(n,rv))return rv.c_str();else return NULL;}
	const TCHAR *GetListText(int n){static ablib::string rv;if(m_buf.GetStr(n,rv))return rv.c_str();else return NULL;}
	void Destroy(){if(::IsWindow(m_hWnd))::DestroyWindow(m_hWnd);}
	int GetCount() const{return m_buf.GetShowCount();}
	int GetSelect() const{if(m_buf.m_issel)return m_buf.m_selindex;else return -1;}
	int GetTextCount() const{return m_buf.GetLineCount();}
	bool IsShow() const{return m_isshow;}
	bool IsExist() const{return ::IsWindow(m_hWnd) != FALSE;}
	HWND GetHWND() const{return m_hWnd;}
	int GetWindowHeight(){return m_vsize * TextHeight() + 2;}
	int GetCommentWindowHeight(){return TextHeight() + 1;}

private:
	BEGIN_MSG_MAP_EX(ListBoxWnd)
		MSG_WM_CREATE(OnCreate);
		MSG_WM_PAINT(OnPaint);
		MSG_WM_VSCROLL(OnVScroll);
		MSG_WM_LBUTTONDOWN(OnLButtonDown);
		MSG_WM_DESTROY(OnDestroy);
		CHAIN_MSG_MAP(CScrollWindowImpl<ListBoxWnd>);
	END_MSG_MAP()

	int m_vsize,m_hsize;
	bool m_isshow;
	bool m_comment;
	HWND m_parent;
	WTL::CFont m_font;
	WTL::CPen m_dotpen;
	TEXTMETRIC m_fontdata;

	LRESULT OnCreate(LPCREATESTRUCT lpCreateStruct);
	void OnPaint(HDC /*hDC*/);
	void OnPaint(){OnPaint(NULL);}
	void OnVScroll(int nSBCode, short nPos, HWND hWnd);
	void OnLButtonDown(UINT nFlags, WTL::CPoint point);
	void OnDestroy();

	void SetScroll(int pos);
	int TextHeight(){return m_fontdata.tmHeight + 2;}
	ablib::string m_fontname;
	int m_fontsize;

	//Rg
	class CommentWnd : public CWindowImpl<CommentWnd>{
	public:
		DECLARE_WND_CLASS(_T("ForTeXListBoxComment"));
		CommentWnd(Buffer *b);
		HWND Create(HWND p){return CWindowImpl::Create(p);}
		void SetListWnd(HWND wnd){m_listwnd = wnd;}
		void SetShow(bool b){m_isshow = b;}
		void SetFont(const ablib::string &fontname,int fontsize);
		void OnPaint(){OnPaint(NULL);}

	private:
		BEGIN_MSG_MAP_EX(CommentWnd);
			MSG_WM_PAINT(OnPaint);
			MSG_WM_CREATE(OnCreate);
		END_MSG_MAP();
		void OnPaint(HDC /*hDC*/);
		LRESULT OnCreate(LPCREATESTRUCT lpCreateStruct);

		Buffer *m_buf;
		HWND m_listwnd;
		TEXTMETRIC m_fontdata;
		int TextHeight(){return m_fontdata.tmHeight + 2;}
		bool m_isshow;
		bool m_commentfix;
		friend class ListBoxWnd;
		ablib::string m_fontname;
		int m_fontsize;

		WTL::CFont m_font,m_boldfont;
	}m_comwnd;
	NOCOPY(ListBoxWnd);
};

#endif//__LISTBOXWND_H__

